Subject: RE: How to Reorder/Detect packet loss in case of Payload L2TP pa ckets?

From: Vipin Jain <[email-masked]>
Date: Thu, 13 Apr 2000 17:19:00 -0700

> If you see the section mentioned about, it says LNS can reorder the packet
> or detect packet loss. I could'nt see any way to do that. ( may be some
> timer!!)
How to detect packet loss is implementation specific, I think.
Only information LNS has to conclude something from, is sequence numbers.
Using timers is one way; Other implementation could assume
that packet is lost if its queues are full.

- Vipin

---

From: William Dixon <[email-masked]>
Date: Fri, 14 Apr 2000 15:13:09 -0700

Don't forget that IPSec mandates sequence numbers as well for both AH & ESP
and anti-replay protection on the receiving SA, which uses either a 32 or 64
packet window (sufficient to detect packet loss, since receiver must discard
outside of this window).  So if you want one general mechanism for both
IPSec tunnels & L2TP/IPSec tunnels to detect packets loss, I'd put it in
IPSec and have L2TP report it.  I realize this doesn't apply to L2TP clear
packets, but I'd hate to see interop requirements develop to include L2TP
sequence numbers just to detect packet loss.

-----Original Message-----
From: W. Mark Townsley [mailto:[email-masked]]
Sent: Thursday, April 13, 2000 4:58 PM
To: Evan Caves
Cc: [email-masked]; [email-masked]
Subject: Re: How to Reorder/Detect packet loss in case of Payload L2TP
packets?

Evan Caves wrote:
> 
> Srikrishnan wrote:
> 
> > "W. Mark Townsley" wrote:
> >
> > > Srikrishnan wrote:
> > > >
> > > > Hi,
> > > >
> > > >    L2TP RFC 2661 section 5.4 (give below)
> > > > "Unlike the L2TP control channel, the L2TP data channel does not use
> > > >    sequence numbers to retransmit lost data messages. Rather, data
> > > >    messages may use sequence numbers to detect lost packets and/or
> > > >    restore the original sequence of packets that may have been
reordered
> > > >
> > > >    during transport.  The LAC may request that sequence numbers be"
> > > >
> > > >    proposes that Sequence Numbers in Payload can be used for
> > > >    reordering of data packets and/or detect packets lost.
> > > >
> > > >    But how can a packet be detected if we cant resynchronize the
> > > >    Sequence number after the first packet loss.
> > > >
> > > >     For ex:  If sequence 1,2,3 sent by LAC to LNS and 2 is lost. By
> > > >     what mechanism   will LNS detect the packet loss?
> > >
> > > If 2 is lost, the LNS would not see it. The LNS would only see 1 and
3.
> > >
> >
> > My Point is exactly that, at the time of getting 3, how could LNS
conclude
> > whether the packet 2 is lost or delayed in the network?
> > As its not serial link, there is lot of chances that the packet 2 may be
> > delayed.
> >
> Yes you would need to use some kind of timer mechanism and possibly force
> flush based on queue depth.

Yes. But don't wait around too long as you don't want to cause the
higher layer (e.g. TCP) RTT calculations to get skewed heavily. If you
must reorder, I would recommend a very short queue with depth flush as
Evan mentioned, and perhaps a short timer as well if you can afford it
(this all depends on your scalability requirements). 

For L2 tunneled IP data packets (without stateful compression or
encryption of course), I have seen little reason in practice not to go
ahead and pass data as it is received - in order or not.

> 
> evan
> -
> 
> >
> >
> > Your response will be appreicated.
> >
> > Thanks in Advance,
> > Srikrishnan.

---

From: Barney Wolff <[email-masked]>
Date: Fri, 14 Apr 2000 21:41 EDT

But the requirement is already there, that either side can insist on
sequence numbers in the data channel.  How is interoperability aided
by allowing some systems to evade requirements that other systems
count on?  I don't consider myself a layering purist, but imho
introducing an l2tp-lite that works only over ipsec would be a mistake.

Barney Wolff

> From: William Dixon <[email-masked]>
> Date: Fri, 14 Apr 2000 15:13:09 -0700
>